;Always the first step: load the VIGRA CL Lib
(load "vigracl.cl")

(in-package :vigracl)
;read the image
(print "loading rect-image")
(time (setq imgrect (loadimage "rect.gif")))

;do fast fourier transform
(print "performing fft on image")
(time (setq imgrectfft (fouriertransform imgrect)))

; Calculate the amplitude of the frequency spectrum
(setq imgfft (array-map #'(lambda(real imag) 
			    (sqrt (+ (* real real) (* imag imag))))
			(car imgrectfft) 
			(cdr imgrectfft)))

; Save:
       ;real part
(saveimage (car imgrectfft) "rect-fft-real.png")
       ;imaginary part
(saveimage (cdr imgrectfft) "rect-fft-imag.png")
       ;amplitude
(saveimage imgfft "rect-fft.png")
       ;amplitude (sqrt scaled)
(saveimage (array-map #'sqrt imgfft) "rect-fft-sqrt.png")
