#include "vigra/basicimage.hxx"
#include "vigra/basicimageview.hxx"
#include "vigra/flatmorphology.hxx"
#include "os_settings.hxx"

LIBEXPORT int vigra_discerosion_c(const float *arr, const float *arr2,const  int width,const  int height,const  int radius){ 
    try
    {
      // create a gray scale image of appropriate size
      vigra::BasicImageView<float> img(arr, width, height);
      vigra::BasicImageView<float> img2(arr2, width, height);
            
	  vigra::BImage tmp(width, height),tmp2(width, height);
	  
	  vigra::copyImage(srcImageRange(img), destImage(tmp));
            
      vigra::discErosion(srcImageRange(tmp), destImage(tmp2), radius);
	  
	  vigra::copyImage(srcImageRange(tmp2), destImage(img2));
    }
    catch (vigra::StdException & e)
    {
        return 1;
    }
    return 0;
}

LIBEXPORT int vigra_discdilation_c(const float *arr, const float *arr2,const  int width,const  int height,const  int radius){ 
    try
    {
      // create a gray scale image of appropriate size
      vigra::BasicImageView<float> img(arr, width, height);
      vigra::BasicImageView<float> img2(arr2, width, height);
	  
	  vigra::BImage tmp(width, height),tmp2(width, height);
	  
	  vigra::copyImage(srcImageRange(img), destImage(tmp));
            
      vigra::discDilation(srcImageRange(tmp), destImage(tmp2), radius);
	  
	  vigra::copyImage(srcImageRange(tmp2), destImage(img2));
    }
    catch (vigra::StdException & e)
    {
        return 1;
    }
    return 0;
}