;Load dll under windows, dylib under MacOS
(if (null (search "Mac" (lisp-implementation-version) :test #'char-equal))
  (load "vigra_c.dll")
  (load "vigra_c.dylib"))
  
(defpackage :vigracl.helpers
  (:use  :common-lisp)
  (:export :copy-array 
	   :array-map
	   :array-map!
	   :array-reduce
	   :array-for-each-index))
	   
(load "vigracl.helpers.cl")	    

(defpackage :vigracl.impex
  (:use  :common-lisp)
  (:export :loadimage 
	   :saveimage))

(load "vigracl.impex.cl")


(defpackage :vigracl.imgproc
  (:use :common-lisp)
  (:export :resizeimage
	   :rotateimage
	   :affinewarpimage
	   :reflectimage
	   :fouriertransform))

(load "vigracl.imgproc.cl")


(defpackage :vigracl.filters
  (:use  :common-lisp)
  (:export :gsmooth
	   :ggradient
	   :laplacianofgaussian
	   :gsharpening
	   :sharpening
	   :nonlineardiffusion 
	   :distancetransform))

(load "vigracl.filters.cl")


(defpackage :vigracl.segmentation
  (:use  :common-lisp)
  (:export :labelimage
	   :watersheds
	   :cannyedgeimage
	   :differenceofexponentialedgeimage
	   :regionimagetocrackedgeimage))

(load "vigracl.segmentation.cl")

(defpackage :vigracl.morphology
  (:use  :common-lisp)
  (:export :erodeimage
	   :dilateimage
	   :openingimage
	   :closingimage))

(load "vigracl.morphology.cl")

(defpackage :vigracl
	(:use 	:common-lisp
			:vigracl.helpers
			:vigracl.impex
			:vigracl.imgproc
			:vigracl.filters
			:vigracl.segmentation
			:vigracl.morphology))

	