(in-package vigracl.impex)

;###############################################################################
;############ Getting Dimensions and # of Bands of an image-file    ############

(ff:def-foreign-call get_width_c 
    ((filename (* :char) string))
  :returning  (:int fixnum)
  :STRINGS-CONVERT t )

(ff:def-foreign-call get_height_c 
    ((filename (* :char) string))
  :returning  (:int fixnum)
  :STRINGS-CONVERT t )

(ff:def-foreign-call get_numBands_c 
    ((filename (* :char) string))
  :returning  (:int fixnum)
  :STRINGS-CONVERT t )


;###############################################################################
;###################             Loading images             ####################

(ff:def-foreign-call vigra_importimage_c
    ((arr      (:array :float))
     (width    :int fixnum) 
     (height   :int fixnum)
     (filename (* :char) string))
  :returning  (:int fixnum)
  :STRINGS-CONVERT t )

(defun loadimage (filename)
  (let* ((width  (get_width_c filename))
	 (height (get_height_c filename))
	 (arr    (make-array (list width height) 
			     :element-type '(single-float)
			     :initial-element 0.0))
	 (foo    (vigra_importimage_c arr width height filename)))
    (case foo
      ((0) arr)
      ((1) "Error in vigracl.impex.loadimage: Image cannot be loaded by vigra!")
      ((2) "Error in vigracl.impex.loadimage: Image is not grayscale!")
      ((3) "Error in vigracl.impex.loadimage: Sizes do not match!"))))


;###############################################################################
;###################             Saving images              ####################

(ff:def-foreign-call vigra_exportimage_c
    ((arr      (:array :float))
     (width    :int fixnum) 
     (height   :int fixnum)
     (filename (* :char) string))
  :returning  (:int fixnum)
  :STRINGS-CONVERT t )

(defun saveimage (arr filename)
  (let* ((width  (array-dimension arr 0))
	 (height (array-dimension arr 1))
	 (foo   (vigra_exportimage_c arr width height filename)))
    (case foo
      ((0) t)
      ((1) "Error in vigracl.impex.saveimage: Image cannot be saved by vigra!"))))

