(in-package vigracl.morphology)

;###############################################################################
;###################         Erosion                        ####################

(ff:def-foreign-call vigra_discerosion_c 
    ((arr      (:array :float))
     (arr2     (:array :float))
     (width    :int fixnum) 
     (height   :int fixnum)
     (radius :int fixnum)) 
  :returning  (:int fixnum))

(defun erodeimage (arr radius)
  (let* ((width  (array-dimension arr 0))
	 (height (array-dimension arr 1))
	 (arr2 (make-array (list width height)
			   :element-type (array-element-type arr)
			   :initial-element 0.0))
	 (foo   (vigra_discerosion_c arr arr2 width height   radius)))
    (case foo
      ((0) arr2)
      ((1) "Error in vigracl.morphology:erodeimage: Erosion of image failed!!"))))

;###############################################################################
;###################         Dilation                       ####################

(ff:def-foreign-call vigra_discdilation_c 
    ((arr      (:array :float))
     (arr2     (:array :float))
     (width    :int fixnum) 
     (height   :int fixnum)
     (radius :int fixnum)) 
  :returning  (:int fixnum))

(defun dilateimage (arr radius)
  (let* ((width  (array-dimension arr 0))
	 (height (array-dimension arr 1))
	 (arr2 (make-array (list width height)
			   :element-type (array-element-type arr)
			   :initial-element 0.0))
	 (foo   (vigra_discdilation_c arr arr2 width height   radius)))
    (case foo
      ((0) arr2)
      ((1) "Error in vigracl.morphology:dilateimage: Dilation of image failed!!"))))


;###############################################################################
;###################         Opening                        ####################

(defun openingimage (arr radius)
  (dilateimage (erodeimage arr radius) radius))


;###############################################################################
;###################         Closing                        ####################

(defun closingimage (arr radius)
  (erodeimage (dilateimage arr radius) radius))

